summaryrefslogtreecommitdiffstats
path: root/target/imagebuilder/files/opkg-generate-config.sh
diff options
context:
space:
mode:
authorjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-09-08 00:36:35 +0000
committerjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-09-08 00:36:35 +0000
commit67f09fa245578c136ac34804dad41f1e1d694e48 (patch)
tree0cd524ba71085d2707940f9521147c62f32d4407 /target/imagebuilder/files/opkg-generate-config.sh
parentfeaf88f721ae706a43e144f7b7975d915aad4d7e (diff)
[imagebuilder]
- add a helper script to generate opkg.conf, attempt to detect package architecture from packages/ - fix package defaults when no package override is given, IB previously aggregated the defautls of all profiles - introduce a repositories.conf, allows using remote opkg repositories in imagebuilder git-svn-id: svn://svn.openwrt.org/openwrt/trunk@22978 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/imagebuilder/files/opkg-generate-config.sh')
-rwxr-xr-xtarget/imagebuilder/files/opkg-generate-config.sh45
1 files changed, 45 insertions, 0 deletions
diff --git a/target/imagebuilder/files/opkg-generate-config.sh b/target/imagebuilder/files/opkg-generate-config.sh
new file mode 100755
index 000000000..a385d9fa9
--- /dev/null
+++ b/target/imagebuilder/files/opkg-generate-config.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+TOPDIR="$(pwd)"
+TARGETDIR="${1}"
+
+[ -f "$TOPDIR/scripts/${0##*/}" ] || {
+ echo "Please execute within the toplevel directory" >&2
+ exit 1
+}
+
+# Try to find package architecture from packages directory
+PKGARCH=
+for pkg in $TOPDIR/packages/*.ipk; do
+ if [ -f "$pkg" ]; then
+ PKGARCH="${pkg##*_}"
+ PKGARCH="${PKGARCH%.ipk}"
+ [ "$PKGARCH" = all ] || break
+ fi
+done
+
+# Try to find package architecture from the target directory
+[ -n "$PKGARCH" ] || {
+ PKGARCH="${TARGETDIR##*/root-}"
+ [ "$PKGARCH" != "$TARGETDIR" ] || {
+ echo "Cannot determine package architecture" >&2
+ exit 1
+ }
+}
+
+rm -f $TOPDIR/tmp/opkg.conf
+
+[ -f $TOPDIR/repositories.conf ] && \
+ $TOPDIR/staging_dir/host/bin/sed \
+ -n -e "s/\$A/$PKGARCH/g" -e "/^[[:space:]*]src/p" \
+ $TOPDIR/repositories.conf > $TOPDIR/tmp/opkg.conf
+
+cat <<EOT >> $TOPDIR/tmp/opkg.conf
+dest root /
+arch all 100
+arch $PKGARCH 200
+option offline_root $TARGETDIR
+src imagebuilder file:$TOPDIR/packages
+EOT
+
+exit 0